Show thumbnails for PDF attachments
Assignee: Go MAEDA % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed   

Description

If GhostScript is installed, ImageMagick is able to handle PDF files as well. This could be used to create thumbnails for PDF

attachments.

The attached patch adds this feature. It is based on current trunk (r15332)

It does a couple of things:

It adds a Redmine::Thumbnail::gs_available?

This method tries to determine if GhostScript is installed. It does so by checking if GhostScript binaries are found in the PATH. This

might be insufficient, since ImageMagick might be configured to use the GhostScript libraries without the binaries being installed. But

this is rather unlikely.

This property is also made available in /admin/info and descriptions for English and German are added.

Attachment#thumbnailable? is extended

So that, if GhostScript is available, PDFs are also considered thumbnailable

Redmine::Thumbnail::generate is extended

to create PDF thumbnails. Thumbnails will only show the first page ([0] at the end of source parameter) and they will be stored in

PNG format (png: at the beginning of target parameter).

AttachmentController#detect_content_type is extended

to return image/png if an attachment thumbnail of a PDF is rendered. In all other cases the thumbnails format used to match the

attachment's. But this was not feasible for PDF files.

Related issues:

Related to Redmine - Feature #22915: Additional filetypes (tif,tiff) for thum... New

Related to Redmine - Feature #25988: Preview files by default instead of down... Closed

Related to Redmine - Defect #32307: AttachmentsControllerTest#test_thumbnail_... Closed

Related to Redmine - Feature #32898: PDF thumbnails support on Windows Closed

Related to Redmine - Defect #33283: Thumbnail support for PDF attachments may... Closed

Has duplicate Redmine - Feature #16626: Preview first page pdf file as a jpg ... Closed

Associated revisions

Revision 18158 - 2019-05-12 05:55 - Go MAEDA

Render PDF thumbnail using ImageMagick/GhostScript (#22481).

Patch by Gregor Schmidt.

Revision 18159 - 2019-05-12 07:43 - Go MAEDA

Test for r18158 (#22481).

Patch by Go MAEDA.
Revision 18160 - 2019-05-12 07:47 - Go MAEDA

Update locales (#22481).

Revision 18221 - 2019-06-03 01:39 - Go MAEDA

Run test only when GhostScript is available (#22481).

Patch by Marius BALTEANU.

Revision 18826 - 2019-10-22 16:12 - Go MAEDA

Skip AttachmentsControllerTest#test_thumbnail_for_pdf_should_be_png when ImageMagick convert is not available (#32307, #22481).

Patch by Go MAEDA.

History

#1 - 2016-04-13 14:03 - Gregor Schmidt

- File 0001-Render-PDF-thumbnail-using-ImageMagick-GhostScript.patch added

- File pdf-thumb.png added

I have attached an updated patch. The first one (now obsolete) was missing a change in Attachment, I had introduced locally for the changes in 

#22482.

I have also added a screen shot previewing the feature.

 pdf-thumb.png 

#2 - 2016-04-13 15:12 - Jan from Planio www.plan.io

- File deleted (0001-Render-PDF-thumbnail-using-ImageMagick-GhostScript.patch)

#3 - 2016-04-13 15:15 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#5 - 2016-05-11 18:10 - Toshi MARUYAMA

LGTM.

#6 - 2016-05-27 16:59 - kay rus

Gregor, I guess you have to update your patch because of this new feature: 

https://github.com/redmine/redmine/commit/bf81c96b79cc80bc4ffb08714a3d3f92e68e254a

You can find some hits here: http://www.redmine.org/attachments/16039/pdf_thumbnails.patch

And in addition, I guess you can add tiff support ([0] is also necessary here, so I'd suggest you to add "[0]" for all images, not only for pdf, it works in

my patch as well), and add some tests.

#7 - 2016-05-30 10:56 - Gregor Schmidt

- File 0001-Render-PDF-thumbnail-using-ImageMagick-GhostScript.patch added

Attached you may find an updated patch (trunk r15429)

#8 - 2016-05-30 11:05 - Gregor Schmidt

상경 김 rus: Thanks for additionally suggesting TIFF support in #22915. I did not include your changes into my patch to keep this issue focused. I

assume, adding tiff after this change was applied will be just as easy.

#9 - 2016-06-12 16:52 - Go MAEDA

- Related to Feature #22915: Additional filetypes (tif,tiff) for thumbnails generation added

#10 - 2017-04-27 15:21 - Go MAEDA

- Has duplicate Feature #16626: Preview first page pdf file as a jpg file added

#11 - 2017-05-04 11:15 - Go MAEDA

- File Render-PDF-thumbnail-using-ImageMagick-GhostScript-20170504.patch added

2025-05-02 2/5

https://www.redmine.org/issues/22482
https://github.com/redmine/redmine/commit/bf81c96b79cc80bc4ffb08714a3d3f92e68e254a
http://www.redmine.org/attachments/16039/pdf_thumbnails.patch
https://www.redmine.org/projects/redmine/repository/svn/revisions/15429
https://www.redmine.org/users/36507
https://www.redmine.org/issues/22915


- Target version changed from Candidate for next minor release to 3.4.0

It is a great feature. We can easy guess the content of attached PDF files by seeing its thumbnail.

I updated the patch for the current trunk. Let's deliver this feature in the upcoming version.

#12 - 2017-06-04 13:44 - Go MAEDA

- Related to Feature #25988: Preview files by default instead of downloading them added

#13 - 2017-06-10 10:26 - Jean-Philippe Lang

- Target version changed from 3.4.0 to 4.1.0

I've just tried it on win64. gswin64 -version opens up a GS window and webrick waits until it's closed.

#14 - 2017-06-10 10:32 - Jean-Philippe Lang

And after that, PDF support is still marked as unavailable in admin/infos.

#15 - 2017-09-27 05:57 - Jens Krämer

I played around with this a bit and it seems that Ghostscript on Windows always opens this window, so it's pretty useless to use as a check.

As Gregor mentioned checking for presence of the GS executable in itself is a bit unreliable as well, since ImageMagick still might be built without

PDF support. Unfortunately convert -list format, which lists ImageMagick's supported file types, still lists PDF even with Ghostscript not present, it

merely checks what options it was compiled with but does not actually look up the actual runtime dependencies (ghostscript libraries). That's

consistent with the information I found on imagemagick.org . The only reliable way to determine if a certain file type can be handled is to actually try it

out.

We could either:

- try to actually thumbnail a PDF once in gs_available?

- or resort to just checking the presence / executability of the Ghostscript binary

- or introduce an option to manually enable PDF thumbnailing with proper documentation ("install ghostscript!") and completely remove the

Ghostscript availability check. The more I think about it this might be the best thing to do.

Thoughts?

#16 - 2017-09-27 06:16 - Go MAEDA

Jens Krämer wrote:

- or introduce an option to manually enable PDF thumbnailing with proper documentation ("install ghostscript!") and completely remove the

Ghostscript availability check. The more I think about it this might be the best thing to do.

 +1 for this. This is the most efficient and reliable way in the options, I think.

#17 - 2018-07-03 13:05 - Go MAEDA

Jens Krämer wrote:

We could either:

- try to actually thumbnail a PDF once in gs_available?

- or resort to just checking the presence / executability of the Ghostscript binary

- or introduce an option to manually enable PDF thumbnailing with proper documentation ("install ghostscript!") and completely remove the

Ghostscript availability check. The more I think about it this might be the best thing to do.

 Another idea. I think there are not many people run Redmine for production on Windows, so we can simply reject Windows.

    def self.gs_available?

      return @gs_available if defined?(@gs_available)

      if ENV['OS'] == 'Windows_NT'

        @gs_available = false

      else

        @gs_available = system("gs -version") rescue false

        @gs_available ||= system("gswin32 -version") rescue false

        @gs_available ||= system("gswin64 -version") rescue false

      end

      @gs_available
#18 - 2018-07-18 11:20 - Stephan Wenzel

My experience with imagemagick ist, that it is not very reliable with respect to predictability of its capabilities on different platforms. Why not let the

user try on a setup page, if imagemagick is capable to handle pdf?

On GitHub and Redmine.org have shared two plugins [[https://www.redmine.org/plugins/redmine_preview_pdf]] and [[

https://www.redmine.org/plugins/redmine_thumbnail_pdf]] that use the pdf capabilities of imagemagick. I will introduce a try-if-pdf-is-availbale option

on it's setup page.

#19 - 2018-07-24 00:44 - Marius BĂLTEANU

Go MAEDA wrote:

Another idea. I think there are not many people run Redmine for production on Windows, so we can simply reject Windows.

 I’m in favour of rejecting Windows.

#20 - 2019-01-10 09:23 - Go MAEDA

I found that Redmine has Redmine::Platform.mswin? method. We don't have to check ENV['OS'].

This should be OK.

    def self.gs_available?

      return @gs_available if defined?(@gs_available)

      unless Redmine::Platform.mswin?

        @gs_available = system("gs -version") rescue false

      else

        @gs_available = false

      end

      @gs_available

    end

#21 - 2019-03-26 09:42 - Go MAEDA

- File Render-PDF-thumbnail-using-ImageMagick-GhostScript-20190326.patch added

Updated the patch for r18003. Now the feature is disabled if Redmine is running on Windows.

#22 - 2019-05-11 06:55 - Go MAEDA

- File Render-PDF-thumbnail-using-ImageMagick-GhostScript-20190511.patch added

Updated the patch for the current trunk r18155.

#23 - 2019-05-11 09:46 - Go MAEDA

- File 0001-Test-for-22481.patch added

- File 190511141819_ecookbook-gantt.pdf added

I wrote tests for the patch. I think the patch is ready to commit.

#24 - 2019-05-12 07:44 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for the great improvement.

#25 - 2019-06-02 19:16 - Marius BĂLTEANU

- File 0001-Run-test-only-when-GhostScript-is-available.patch added

- Status changed from Closed to Reopened

We should run  test_thumbnail_for_pdf_should_be_png only when GS is available.
One test fails without the patch: https://gitlab.com/redmine-org/redmine/-/jobs/223654807

All tests pass after applying the patch: https://gitlab.com/redmine-org/redmine/-/jobs/223683936

#26 - 2019-06-03 01:40 - Go MAEDA

- Status changed from Reopened to Closed

Marius BALTEANU wrote:

We should run  test_thumbnail_for_pdf_should_be_png only when GS is available.

 Thank you for cleaning up after my mistake. Committed the fix in r18221.

#27 - 2019-10-22 16:58 - Marius BĂLTEANU

- Related to Defect #32307: AttachmentsControllerTest#test_thumbnail_for_pdf_should_be_png fails if ImageMagick convert is not available added

#28 - 2020-01-21 05:11 - Anonymous

For windows, use "gswin64c(32c).exe"(command line version) instead of "gswin64(32).exe".

Now it's working on windows.

--- org/lib/redmine/thumbnail.rb

+++ patch/lib/redmine/thumbnail.rb

@@ -77,5 +77,6 @@

       if Redmine::Platform.mswin?

-        @gs_available = false

+        @gs_available = system("gswin64c -version > nul 2>&1") rescue false

+        @gs_available ||= system("gswin32c -version > nul 2>&1") rescue false

       else

         begin

#29 - 2020-01-28 04:25 - Go MAEDA

- Related to Feature #32898: PDF thumbnails support on Windows added

#30 - 2020-04-07 07:43 - VVD VVD

Created a separate issue: #33283.

#31 - 2020-04-20 15:14 - Go MAEDA

- Related to Defect #33283: Thumbnail support for PDF attachments may not be detected added

Files

0001-Render-PDF-thumbnail-using-ImageMagick-GhostScript.patch 7.64 KB 2016-04-13 Gregor Schmidt

pdf-thumb.png 27.1 KB 2016-04-13 Gregor Schmidt

0001-Render-PDF-thumbnail-using-ImageMagick-GhostScript.patch 7.89 KB 2016-05-30 Gregor Schmidt

Render-PDF-thumbnail-using-ImageMagick-GhostScript-20170504.patch6.91 KB 2017-05-04 Go MAEDA

Render-PDF-thumbnail-using-ImageMagick-GhostScript-20190326.patch6.94 KB 2019-03-26 Go MAEDA

Render-PDF-thumbnail-using-ImageMagick-GhostScript-20190511.patch7.13 KB 2019-05-11 Go MAEDA

0001-Test-for-22481.patch 122 KB 2019-05-11 Go MAEDA

190511141819_ecookbook-gantt.pdf 96.7 KB 2019-05-11 Go MAEDA

0001-Run-test-only-when-GhostScript-is-available.patch 4.57 KB 2019-06-02 Marius BĂLTEANU
